# Contributing

Contributions are welcome. Please ensure to follow the guidelines descibed here.

## Contributions Guidelines

All contributions must abide by the following rules:

1. All new feature must be documented in the header (`.hpp`) files
2. All new sample must use the library folder

## Contributing Workflow

Please use the following contribution workflow:

1. Create a branch (or fork) to hold the proposed changes
	1. Branch names should follow the convention: 
		* _feature/feature-description_ (e.g. feature/gpio-output)
		* _bug/bug-description_ (e.g. bug/gpio-initialisation) 
		* _sample/sample-description_ (e.g. sample/gpio-output)
		* _refactor/refactor-description_ (e.g. refactor/gpio-output-remove-duplicate-code)
2. Make some changes, commit the in the created branch, and push when your done
	1. Before pushing your branch try to rebase your branch with `master`

3. Create a _Merge Request_ (MR) for the change(s) and assign it to one of the reviewers listed below

> Note: Unless explicitely accepted by a reviewer, only MRs for changes based on the latest commit of the **master branch** will be accpeted. Therefore, please ensure to rebase the branch containing your changes on top of `master` before submitting. This is meant to keep thinkgs simple and maintain a clean linear project history.

## Release Workflow

Please use the following release workflow:

> Releases should only created from the `master` branch.

1. Make sure all desired MRs have been merged back to `master`

2. Create one last MR to update the [CHANGELOG](CHANGELOG.md)

3. Take note of the commit SHA representing that last MR

4. Make sure the pipeline execution of that commit completed successfully

5. Create a tag of that commit (which should now be the HEAD of `master`) directly from the gitlab web UI.

	1. Copy and paster the new section added to the CHANGELOG as the release notes for the tag in gitlab
	- Filling in the _Release Notes_ field when creating a tag will automatically create `Release` for the project and associate it to this tag

## Project Reviewers

Currently, the reviewers/approvers of this project are:

- @felixLeChat
- @GM024
- @HorbyB
- @Spiritus2424
